#include <stdio.h>
#include <pc.h>
#include <conio.h>

#define LPT1        0x378
#define LPT2        0x278
#define LPT_PORT    LPT1


#define STROBE  (1<<0)
#define FEED    (1<<1)
#define INIT    (1<<2)
#define SELECT  (1<<3)

#define ACN     0x40
#define BUSY    0x80  /* Busy is inverted */


#define REQUEST  FEED    /* Feed   -> Busy : Request     */
#define DSTROBE  STROBE  /* Strobe -> Acn  : Data Strobe */

int DMXput (int lpt, unsigned char *data, int anz)
{
    if (data && anz)
    {
        int             i;
        unsigned int    d=0;

        outportb (lpt, 0);
        outportb (lpt+2, REQUEST);
        for (d=0; d<200 && !(inportb (lpt+1) & ACN); d++);
        outportb (lpt+2, 0);
        for (d=0; d<200 && (inportb (lpt+1) & ACN); d++);

        if (d<200)
        {
            d=0;
            for (i=0; i<anz && i<48 && d<40000; i++)
            {
                outportb (lpt, data[i]);

                outportb (lpt+2, DSTROBE);
                for (d=0; d<200 && !(inportb (lpt+1) & ACN); d++);
                outportb (lpt+2, 0);
                for (d=0; d<200 && (inportb (lpt+1) & ACN); d++);
            }
        }
#if 0
        if (d>50)
#endif
            {gotoxy (1,2); printf ("err: tout%d", d);fflush(stdout);}
    }
    return (anz>100)?100:anz;
}

void DMXinit (int lpt)
{
    outportb (lpt+2, 0);
}

void main ()
{
    unsigned char   dmx[100];
    int             c,i,nr=0;

    DMXinit (LPT_PORT);
    for (i=0; i<100; i++) dmx[i]=0;
    clrscr ();
    for (i=0; i<100; i++)
    {
        gotoxy (1+(i%20)*4, 3+(i/20)*3);
        printf ("%03d", i+1);

        gotoxy (1+(i%20)*4, 4+(i/20)*3);
        printf ("%03d", dmx[i]);

        gotoxy (1+(i%20)*4, 5+(i/20)*3);
        printf ((i==nr)?"===":"   ");
    }

    do
    {
        fflush (stdout);
        c=getch ();
        gotoxy (1+(nr%20)*4, 5+(nr/20)*3);
        printf ("   ");
        switch (c)
        {
            case 27: break;
            case 's': /* rechts*/
                nr++;
                break;
            case 'a': /* links */
                nr--;
                break;
            case 'w': /* oben */
                nr-=20;
                break;
            case 'y': /* unten */
                nr+=20;
                break;
            case '+':
                if (dmx[nr]<255) dmx[nr]++;
                break;
             case '-':
                if (dmx[nr]>0)  dmx[nr]--;
                break;
             case ' ':
                if (dmx[nr]>128) dmx[nr] = 0; else dmx[nr] = 255;
                break;
        }
        DMXput (LPT_PORT, dmx, 100);

        gotoxy (1+(nr%20)*4, 5+(nr/20)*3);
        printf ("===");
        gotoxy (1+(nr%20)*4, 4+(nr/20)*3);
        printf ("%03d", dmx[nr]);

    } while (c!=27);
    clrscr ();
}
